# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/03_io.ipynb.

# %% auto 0
__all__ = ['load', 'save', 'action']

# %% ../../nbs/03_io.ipynb 1
from intake.readers.datatypes import recommend, JSONFile
import importlib
from functools import partial

# %% ../../nbs/03_io.ipynb 2
maps = {JSONFile: ["beforerr.io.json"],}

def checkpath(file):
    # Placeholder implementation, replace with actual path checking logic
    pass

def query_datatype(file):
    """query the datatype of a file

    See also `os.path.splitext(file)` to get the file extension
    """
    datatypes = recommend(file)
    if JSONFile in datatypes:
        return JSONFile
    else:
        return datatypes

def applicable_func(datatype, func="load"):
    libraries = maps[datatype]
    lib = libraries[0]
    mod = importlib.import_module(lib)
    return getattr(mod, func)

# %% ../../nbs/03_io.ipynb 3
def action(func, file, *args, **kwargs):
    checkpath(file)
    dp = query_datatype(file)
    return applicable_func(dp, func)(file, *args, **kwargs)

load = partial(action, "load")
save = partial(action, "save")
